<?php
global $mo2f_dirName;
$setup_dirName = $mo2f_dirName.'views'.DIRECTORY_SEPARATOR.'twofa'.DIRECTORY_SEPARATOR.'link_tracer.php';
 include $setup_dirName;
add_action('admin_footer','mo_wpns_start_scan');
?>
    <div class="mo_wpns_setting_layout">
        <div class="malwaresummarydiv" id="mo2f_scan_dash">
			<?php show_summary(); ?>
        </div>
    </div>
    <div class="mo_wpns_setting_layout" id="scan_status_table">
        <div>
            <p class="hmdiv">Scan Modes<a href='<?php echo esc_url($two_factor_premium_doc['Scan Modes']);?>' target="_blank"><span class="dashicons dashicons-text-page" style="font-size:23px;color:#413c69;float: right;"></span></a></p>
        </div>
        <div style="float: left;">
            <p id="scanstatus"></p>
        </div>
        <div class="malwaresummarydiv">
            <div class="mo_wpns_sub_scanmode mo_wpns_msdivl">
                <div class="hdiv"><b>Quick Scan</b></div>
                <hr class="line">
                <p class="mo_wpns_scan_desc">Quick Scan checks all Plugins, Themes and Core files for Vulnerable Code and SQL Injections using PHP malware signatures.</p>
                <input type = "hidden" id = "wpns_scan_nonce" value="<?php echo esc_html(wp_create_nonce('wpns-scan-nonce')) ?>" >
                <input id="quick_scan_button" type="button" name="quick_scan_button" class="mo_wpns_scan_button" value="Quick Scan">
            </div>
            <div class="mo_wpns_sub_scanmode mo_wpns_msdivr mo_wpns_msdivl">
                <div class="hdiv"><b>Standard Scan</b></div>
                <hr class="line">
                <p class="mo_wpns_scan_desc">Standard Scan checks all Plugins, Themes and Core files for external links and compares with the repository as well.</p>
                  <input id="standard_scan_button" type="button" name="standard_scan_button" class="mo_wpns_scan_button" value="Standard Scan">
            </div>
            <div class="mo_wpns_sub_scanmode mo_wpns_msdivl mo_wpns_msdivr">
                <div class="hdiv">
                    <b>Deep Scan</b>
                    <strong><a href="admin.php?page=mo_2fa_upgrade"> <b style="color: red;">[Premium]</b> </a></strong>
                </div>
                <hr class="line">
                <p class="mo_wpns_scan_desc">Deep Scan checks all Plugins, Themes and Core files for RFI, Trojans and Backdoors using advanced signatures and detects blacklisted domains as well.</p>
                <input id="deep_scan_button" type="button" name="deep_scan_button" class="mo_wpns_deep_scan_button" value="Deep Scan">
            </div>
            <div class="mo_wpns_sub_scanmode mo_wpns_msdivr">
                <div class="hdiv"><b>Custom Scan</b></div>
                <hr class="line">
                <p class="mo_wpns_scan_desc">Custom Scan gives you an option to choose which files to scan and what to check for.</p>
                 <input id="custom_scan_button" type="button" name="custom_scan_button" class="mo_wpns_scan_button" value="Custom Scan">
                <input type="button" name="configure_button" class="mo_wpns_scan_button" value="Configure" style="float: right;" id="mo2f_scan_set" onclick="mo2f_wpns_openTabmalware(this)" >
            </div>
        </div>
    </div>
    </div>
    <div class="mo_wpns_setting_layout" id="mo_progress" style="display: none;">
        <div>
            <div style="float: left;">
                <h3 id="progress_message">Scan progress...</h3>
            </div>
            <div id="mo2f_remaining" style="float: right;width: 60%;">
                <h3 id="mo2f_files_remaining" style="float:right;"><span style='font-size: 18px;color:black; font-weight:bold;'>Files Remaining</span> = <span style='color:red;'>Calculating...</span></h3>
                <h3 id="mo2f_time_remaining" style="float:right;margin-right:2%;"><span style='font-size: 18px;color:black; font-weight:bold;'>Time Remaining</span> =  <span style='color:red;'>Calculating...</span></h3>
            </div>
        </div>
        <div id="mo_wpns_progress" class="mo_wpns_progress">
            <div id="mo_wpns_progress_bar" class="mo_wpns_progress_bar">0%</div>
        </div>
        <div id="mo_stop_button_div" style="display: none;">
            <input type="button" name="mo_stop_button" id="mo_stop_button" class="mo_wpns_scan_button" value="Stop Scan" style="margin-left: 45%;">
        </div >
    </div>
    <div id='mo2f_scan_confirm_modal' class="mo_scan_confirm_modal" style="display: none;">
        <div class="" style="margin-left: 13%;">
            <div class="mo_wpns_setting_layout_scan">

                <h1 style="font-size: large; text-align: center;">The first scan would take time. It is advised to do it when your website is not expecting much traffic. Click continue to proceed with the scan.</h1><br>
                <hr>
                <div>
                    <input id="mo2f_scan_continue" type="button" name="mo2f_scan_continue" class="mo_wpns_scan_modal_button" value="Continue" style="margin-left: 225px; margin-right: 100px;">
                    <input id="mo2f_scan_cancel" type="button" name="mo2f_scan_cancel" class="mo_wpns_scan_modal_button" value="Cancel">
                </div>
                <br>
                <input type="checkbox" name="popup_hide" id="popup_hide" value="1"><b style="font-size: medium;">Do not ask for confirmation again(Checking this would start the scan without confirming henceforth).</b></input>
            </div>
        </div>
    </div>

<?php
function mo_wpns_start_scan(){
	if ( ('admin.php' != basename( $_SERVER['PHP_SELF'] )) || (sanitize_text_field($_GET['page']) != 'mo_2fa_malwarescan') ) {
		return;
	}
	$decoded_scan_configuration=json_decode(get_site_option('mo_wpns_scan_status'));
	if(!isset($decoded_scan_configuration)){
		$status=false;
		$scan_mode=false;
	}else {
		$status    = $decoded_scan_configuration->scan_progress;
		$scan_mode = $decoded_scan_configuration->scan_mode;
	}
	?>
    <script>
        var progress_bar,scan_progress,stop_scan_progress;
        var disabled="#b0d2cf";
        var active_scan="#2271b1";
        var errorClass="notice notice-error is-dismissible";
        var successClass="notice notice-success is-dismissible";
        var removeClass = "notice-error notice-success";
        var nonceMessage = "Nonce did not match.";
        var scanOngoingMessage="A scan is currently ongoing.";
        var scanCompleteMessage="Malware Scan has started. You can see the results in scan reports tab after it is completed.";
        var quickScanButtionID = "quick_scan_button";
        var standardScanButtonID = "standard_scan_button";
        var customScanButtonID = "custom_scan_button";

        function set_active_button_with_button_value($active_button_id,$disabled_button1_id,$disabled_button2_id){
            document.getElementById($active_button_id).style.backgroundColor = active_scan;
            document.getElementById($disabled_button1_id).style.backgroundColor = disabled;
            document.getElementById($disabled_button2_id).style.backgroundColor = disabled;
            document.getElementById($active_button_id).value="Scanning...";
        }
        function set_active_button($active_button_id,$disabled_button1_id,$disabled_button2_id){
            document.getElementById($active_button_id).style.backgroundColor = active_scan;
            document.getElementById($disabled_button1_id).style.backgroundColor = disabled;
            document.getElementById($disabled_button2_id).style.backgroundColor = disabled;
        }

        function mo_scan_message_rest(){
            jQuery('#mo_scan_message').show();
            jQuery('#mo_scan_message').empty();
            jQuery("#mo_scan_message").removeClass(removeClass);
        }

        function showMessage(addclass,message){
            jQuery("#mo_scan_message").addClass(addclass);
            jQuery("#mo_scan_message").append(message);
        }
        function showMessageWithscroll(addclass,message){
            jQuery("#mo_scan_message").addClass(addclass);
            jQuery("#mo_scan_message").append(message);
            window.scrollTo({ top: 0, behavior: "smooth"});
        }

        jQuery(document).ready(function(){
            var pop_up = "<?php echo esc_html(get_site_option('mo_wpns_hide_malware_popup')); ?>";

            var newURL = location.href.split("&")[0];
            window.history.pushState('object', document.title, newURL);
            scan_progress= "<?php echo esc_html($status);?>";
            stop_scan_progress= "<?php echo esc_html(get_site_option('mo_stop_scan')); ?>";
            if(scan_progress=="IN PROGRESS"){
                status_progress();
                jQuery('input[name="quick_scan_button"]').attr('disabled', true);
                jQuery('input[name="custom_scan_button"]').attr('disabled', true);
                jQuery('input[name="standard_scan_button"]').attr('disabled', true);
                var mode_scan="<?php echo esc_html($scan_mode); ?>";
                if(mode_scan=="quick_scan"){
                    set_active_button_with_button_value(quickScanButtionID,customScanButtonID,standardScanButtonID);
                }
                else if(mode_scan=="standard_scan"){
                    set_active_button_with_button_value(standardScanButtonID,quickScanButtionID,customScanButtonID);
                }
                else if(mode_scan=="custom_scan"){
                    set_active_button_with_button_value(customScanButtonID,quickScanButtionID,standardScanButtonID);
                }
                document.getElementById("mo_progress").style.display="block";
                document.getElementById('mo_stop_button_div').style.display="block";

                if(stop_scan_progress==1){

                    jQuery('input[name="mo_stop_button"]').attr('disabled', true);
                    jQuery('input[name="mo_stop_button"]').val("Stop Scanning...");
                    document.getElementById('mo_stop_button').style.backgroundColor = disabled;
                }
                progress_bar = setInterval(status_progress, 10000);
            }


            function set_scan(){

                document.getElementById("mo_progress").style.display="block";
                document.getElementById("mo2f_files_remaining").style.display = 'block';
                document.getElementById("mo2f_time_remaining").style.display = 'block';
                document.getElementById("mo2f_remaining").style.display = 'block';

                document.getElementById("progress_message").innerHTML = "Scan progress...";
                document.getElementById("mo2f_files_remaining").innerHTML = "<span style='font-size: 18px;color:black; font-weight:bold;'>Files Remaining</span> = <span style='color:red;'>Calculating...</span>";
                document.getElementById("mo2f_time_remaining").innerHTML = "<span style='font-size: 18px;color:black; font-weight:bold;'>Time Remaining</span> =  <span style='color:red;'>Calculating...</span>";
                jQuery('input[name="mo_stop_button"]').val("Stop Scan");
                document.getElementById('mo_stop_button_div').style.display="block";
                document.getElementById("mo_wpns_progress_bar").style.width= 0 + "%";
                document.getElementById("mo_wpns_progress_bar").innerHTML= 0 + "%";
                progress_bar= setInterval(status_progress, 10000);

                jQuery('input[name="quick_scan_button"]').attr('disabled', true);
                jQuery('input[name="custom_scan_button"]').attr('disabled', true);
                jQuery('input[name="standard_scan_button"]').attr('disabled', true);

            }

        function scan_start_request(scan_type,scanButtonID){
                document.getElementById(scanButtonID).value = "Scanning...";
                var scanOption = new Map();

                if(pop_up == false){
                    document.getElementById("mo2f_scan_confirm_modal").style.display="block";
                }else{
                    scanOption.set("action", "mo_wpns_malware_redirect");
                    scanOption.set("call_type", "malware_scan_initiate");
                    scanOption.set("scan", "scan_start");


                    if(scan_type=="standard") {
                        scanOption.set("quick_scan_button_backgroundColor", disabled);
                        scanOption.set("standard_scan_button_backgroundColor", active_scan);
                        scanOption.set("custom_scan_button_backgroundColor", disabled);
                        scanOption.set("scantype", "standard_scan");
                        scanOption.set("nonce_button", "wpns_scan_nonce");
                        scanOption.set("scan_button", "standard_scan_button");
                        scanOption.set("scan_button_value", "Standard Scan");
                    }else if(scan_type=="quick"){
                        scanOption.set("quick_scan_button_backgroundColor", active_scan);
                        scanOption.set("standard_scan_button_backgroundColor", disabled);
                        scanOption.set("custom_scan_button_backgroundColor", disabled);
                        scanOption.set("scantype", "quick_scan");
                        scanOption.set("nonce_button", "wpns_scan_nonce");
                        scanOption.set("scan_button", "quick_scan_button");
                        scanOption.set("scan_button_value", "Quick Scan");

                    }else if(scan_type=="custom"){
                        scanOption.set("quick_scan_button_backgroundColor", disabled);
                        scanOption.set("standard_scan_button_backgroundColor", disabled);
                        scanOption.set("custom_scan_button_backgroundColor", active_scan);
                        scanOption.set("scantype", "custom_scan");
                        scanOption.set("nonce_button", "wpns_scan_nonce");
                        scanOption.set("scan_button", "custom_scan_button");
                        scanOption.set("scan_button_value", "Custom Scan");
                    }
                    scanOption.set("active_scanbutton_backgroundColor",disabled);
                    set_scan();
                    document.getElementById(quickScanButtionID).style.backgroundColor = scanOption.get("quick_scan_button_backgroundColor");
                    document.getElementById(customScanButtonID).style.backgroundColor = scanOption.get("standard_scan_button_backgroundColor");
                    document.getElementById(standardScanButtonID).style.backgroundColor = scanOption.get("custom_scan_button_backgroundColor");
                    var data={
                        'action':'mo_wpns_malware_redirect',
                        'call_type':'malware_scan_initiate',
                        'scan':'scan_start',
                        'scantype':scanOption.get("scantype"),
                        'nonce':jQuery('#'+scanOption.get("nonce_button")).val()
                    };

                    jQuery.post(ajaxurl, data, function(response){
                        mo_scan_message_rest();
                        if(response == "scanning_already"){
                            showMessageWithscroll(errorClass,scanOngoingMessage);
                            document.getElementById(scanOption.get("scan_button")).value = scanOption.get("scantype");
                            document.getElementById(scanOption.get("scan_button")).style.backgroundColor = disabled;
                        }else{
                            if(response=="ERROR"){
                                showMessageWithscroll(errorClass,nonceMessage);
                            }else if(response=="RECONFIGURE"){
                                showMessageWithscroll(errorClass,"Please save your custom configuration again");
                            }else{
                                showMessage(successClass,scanCompleteMessage);

                            }
                        }

                    });

                }
            }
            jQuery('input[name="quick_scan_button"]').click(function(){
               scan_start_request("quick",quickScanButtionID);

            });
            jQuery('input[name="standard_scan_button"]').click(function(){
                scan_start_request("standard",standardScanButtonID);
            });

            jQuery('input[name="custom_scan_button"]').click(function(){
                scan_start_request("custom",customScanButtonID);
            });

            jQuery('input[name="mo_stop_button"]').click(function(){
                var button_value = document.getElementById("mo_stop_button").value;
                if(button_value == 'Stop Scan'){
                    jQuery('input[name="mo_stop_button"]').attr('disabled', true);

                    jQuery('input[name="mo_stop_button"]').val("Stop Scanning...");
                    document.getElementById('mo_stop_button').style.backgroundColor = disabled;
                    nonce = jQuery('#wpns_scan_nonce').val();
                    var data={
                        'action':'mo_wpns_malware_redirect',
                        'call_type':'malware_scan_terminate',
                        'nonce':nonce,
                    };
                    jQuery("#mo_scan_message").removeClass(removeClass);
                    jQuery.post(ajaxurl, data, function(response){
                        if(response=="NONCE_ERROR"){
                            showMessageWithscroll(errorClass,nonceMessage);
                        }else{

                            jQuery('#mo_scan_message').show();
                            jQuery('#mo_scan_message').empty();
                            showMessageWithscroll(successClass,"Scan is stopping...");
                        }
                    });
                }else{
                    document.getElementById("mo_progress").style.display="none";
                    jQuery('#mo_scan_message').hide();
                    jQuery('#mo_scan_message').empty();
                    jQuery("#mo_scan_message").removeClass(removeClass);
                }
            });

            jQuery('input[name="mo2f_scan_continue"]').click(function(){
                var scan_type, nonce;

                document.getElementById("mo2f_scan_confirm_modal").style.display="none";
                set_scan();
                var quick_scan_value = document.getElementById(quickScanButtionID).value;
                var std_scan_value = document.getElementById(standardScanButtonID).value;
                var custom_scan_value = document.getElementById(customScanButtonID).value;

                if(quick_scan_value == 'Scanning...'){
                    set_active_button(quickScanButtionID,customScanButtonID,standardScanButtonID);
                    scan_type = 'quick_scan';
                    nonce = jQuery('#wpns_scan_nonce').val();
                }else if(std_scan_value == 'Scanning...'){
                    set_active_button(standardScanButtonID,quickScanButtionID,customScanButtonID);
                    scan_type = 'standard_scan';
                    nonce = jQuery('#wpns_scan_nonce').val();
                }else{
                    set_active_button(customScanButtonID,standardScanButtonID,quickScanButtionID);

                    scan_type = 'custom_scan';
                    nonce = jQuery('#wpns_scan_nonce').val();
                }
                var popup_state = jQuery("input[name= popup_hide]:checked").val();
                var data={
                    'action':'mo_wpns_malware_redirect',
                    'call_type':'malware_scan_initiate',
                    'scan':'scan_start',
                    'scantype':scan_type,
                    'nonce':nonce,
                    'hide_popup':popup_state
                };
                jQuery.post(ajaxurl, data, function(response){
                    mo_scan_message_rest();
                    if(response == "scanning_already"){
                        showMessageWithscroll(errorClass,scanOngoingMessage);
                    }else{
                        if(response=="ERROR"){
                            showMessageWithscroll(errorClass,nonceMessage);
                        }else{
                            showMessage(successClass,scanCompleteMessage);
                        }
                    }

                });

            });

            jQuery('input[name="mo2f_scan_cancel"]').click(function(){
                document.getElementById(quickScanButtionID).value = "Quick Scan";
                document.getElementById(standardScanButtonID).value = "Standard Scan";
                document.getElementById(customScanButtonID).value = "Custom Scan";
                document.getElementById("mo2f_scan_confirm_modal").style.display="none";
            });


        var scan_modal_confirm = document.getElementById("mo2f_scan_confirm_modal");
        window.onclick = function(event) {
            if (event.target == scan_modal_confirm) {
                scan_modal_confirm.style.display = "none";
                document.getElementById(quickScanButtionID).value = "Quick Scan";
                document.getElementById(standardScanButtonID).value = "Standard Scan";
                document.getElementById(customScanButtonID).value = "Custom Scan";
            }
        }

    function convertSecondsToHHMMSS(secs){
            estimatedTime="<span style='color:red;'>Calculating...</span>";
            if(secs==0){
               return estimatedTime;
            }
            var sec_num = parseInt(secs, 10);
            var hours   = Math.floor(sec_num / 3600);
            var minutes = Math.floor(sec_num / 60) % 60;
            var seconds = sec_num % 60;

            estimatedTime= [hours,minutes,seconds].map(v => v < 10 ? "0" + v : v).filter((v,i) => v !== "00" || i > 0).join(":");

            estimatedTime="<span style='color:red;'>"+estimatedTime+"</span><span style='color:green;'>s</span>";
            return estimatedTime;

        }

        function scan_response_status(scanset,serverResponse){
            document.getElementById("progress_message").innerHTML = scanset.get("progress_message");
            var bar= document.getElementById("mo_wpns_progress_bar");
            bar.style.width= 100 + "%";
            bar.innerHTML = 100 + "%";
            jQuery('input[name="quick_scan_button"]').removeAttr('disabled');
            document.getElementById(quickScanButtionID).style.backgroundColor = active_scan;
            document.getElementById(quickScanButtionID).value="Quick Scan";
            jQuery('input[name="standard_scan_button"]').removeAttr('disabled');
            document.getElementById(standardScanButtonID).style.backgroundColor = active_scan;
            document.getElementById(standardScanButtonID).value="Standard Scan";
            jQuery('input[name="custom_scan_button"]').removeAttr('disabled');
            document.getElementById(customScanButtonID).style.backgroundColor = active_scan;
            document.getElementById(customScanButtonID).value="Custom Scan";

            jQuery('#summary_all_scan_text').html(serverResponse['total_files']);
            jQuery('#summary_current_scan_text').html(serverResponse['scan_files']);
            jQuery('#summary_all_infect_text').html(serverResponse['total_mal']);
            jQuery('#summary_current_infect_text').html(serverResponse['mal_files']);
            jQuery('#summary_current_warning_text').html(serverResponse['warnings']);

            jQuery('#mo_scan_message').show();
            jQuery('#mo_scan_message').empty();
            showMessageWithscroll(scanset.get("message_class"),scanset.get("message_value"));

            jQuery('input[name="mo_stop_button"]').val("Dismiss bar");
            document.getElementById('mo_stop_button').style.backgroundColor = active_scan;
            jQuery('input[name="mo_stop_button"]').removeAttr('disabled');
            document.getElementById("mo2f_remaining").style.display = 'none';
            clearInterval(progress_bar);
        }
        function status_progress(){
            nonce = jQuery('#wpns_scan_nonce').val();
            var data={
                'action':'mo_wpns_malware_redirect',
                'call_type':'malware_progress_bar',
                'nonce':nonce,
            };
            jQuery.post(ajaxurl, data, function(response){
                var scanset = new Map();

                jQuery("#mo_scan_message").removeClass(removeClass);
                var bar= document.getElementById("mo_wpns_progress_bar");
                if(response=="NONCE_ERROR"){
                    showMessageWithscroll(errorClass,nonceMessage);
                }
                if(response['status']=="COMPLETE"){

                    scanset.set("progress_message", "Scan completed");
                    scanset.set("message_class", successClass);
                    scanset.set("message_value", "Malware Scan is complete. You can see the results in scan reports tab now.");
                    scan_response_status(scanset,response);

                }else if(response['status']=="ABORTED"){

                    scanset.set("progress_message", "Scan Aborted");
                    scanset.set("message_class", errorClass);
                    scanset.set("message_value", "Malware Scan is aborted. You can check the results.");
                    scan_response_status(scanset,response);

                }else{
                    jQuery('#mo_scan_message').hide();
                    jQuery('#mo_scan_message').empty();
                    if(response['total'] === false || response['total'] == 0 || response['total'] == null){
                        var width = 0;
                    }else{
                        var width= (response['scanned']/response['total'])*100;
                        width = Math.round(width);
                        var files_remain = response['total']-response['scanned'];
                        files_remain = Math.round(files_remain);
                        document.getElementById("mo2f_files_remaining").innerHTML="<span style='font-size: 18px;color:black; font-weight:bold;'>Files Remaining </span>= <span style='color:red;'>"+files_remain+"</span>";

                        var averageTimePerFile=response['AverageFileTime'];
                        filesAlreadyProcessed = response['total_files_processed'];
                        totalFilesToProcess= response['total']*(parseInt(response['extlink_check'])+ parseInt(response['repo_scan']) +1);
                        remaining_files_to_process= totalFilesToProcess - filesAlreadyProcessed;
                        estimatedTime= (remaining_files_to_process )* averageTimePerFile;
                        estimatedTime= Math.ceil(estimatedTime);

                        estimatedTime=convertSecondsToHHMMSS(estimatedTime);
                        document.getElementById("mo2f_time_remaining").innerHTML="<span style='font-size: 18px;color:black; font-weight:bold;'>Time Remaining</span> = " +estimatedTime;

                    }
                    bar.style.width= width + "%";
                    if(response['repo_scan']==1 && width==85){
                        document.getElementById("progress_message").innerHTML= "Downloading files from wordpress repository...";
                        bar.innerHTML = width + "%";
                    }else{
                        document.getElementById("progress_message").innerHTML= "Scan in progress. It may take some time...";
                        bar.innerHTML = width + "%";
                    }
                }
            });
        }
    });
    </script>
	<?php
}
function show_summary(){
	$mo_wpns_db_handler = new MoWpnsDB();
	$last_id=$mo_wpns_db_handler->get_last_id();
	$send_id=$last_id[0]->max;
	if(is_null($send_id)){
		$total_scan=0;
		$total_malicious=0;
		$last_scan=0;
		$malicious_last_scan=0;
		$warning_last_scan=0;
	}else{
		$result = $mo_wpns_db_handler->get_report_with_id($send_id);
		$total_scan=$mo_wpns_db_handler->count_files();
		$total_malicious=$mo_wpns_db_handler->count_malicious_files();
		$last_scan=$mo_wpns_db_handler->count_files_last_scan($send_id);
		$malicious_last_scan = get_site_option('mo_wpns_infected_files',0);
		$warning_last_scan = get_site_option('mo_wpns_warning_files',0);
		if($total_scan > 999){
			$total_scan=($total_scan/1000);
			$total_scan= round($total_scan,1)."k";
		}
		if($total_malicious > 999){
			$total_malicious=($total_malicious/1000);
			$total_malicious= round($total_malicious,1)."k";
		}
		if($last_scan > 999){
			$last_scan = ($last_scan/1000);
			$last_scan = round($last_scan,1)."k";
		}
	}
	?>
    <div class="mo_wpns_sub_scansummary mo_wpns_msdivl" id="summary_all_scan">
        <div class="title_hdiv"><b>Total Files Scanned</b></div>
        <hr class="line">
        <p class="wpns_font_size mo_wpns_scan_summary_text" id="summary_all_scan_text"> <?php echo esc_html($total_scan) ?> </p>
    </div>
    <div class="mo_wpns_sub_scansummary mo_wpns_msdivr mo_wpns_msdivl" id="summary_all_infect">
        <div class="title_hdiv"><b>Total Infected Files</b></div>
        <hr class="line">
        <p class="wpns_font_size mo_wpns_scan_summary_text" id="summary_all_infect_text"> <?php echo esc_html($total_malicious) ?> </p>
    </div>
    <div class="mo_wpns_sub_scansummary mo_wpns_msdivl mo_wpns_msdivr" id="summary_current_scan">
        <div class="title_hdiv"><b>Files scanned in last scan</b></div>
        <hr class="line">
        <p class="wpns_font_size mo_wpns_scan_summary_text" id="summary_current_scan_text"> <?php echo esc_html($last_scan) ?> </p>
    </div>
    <div class="mo_wpns_sub_scansummary mo_wpns_msdivl mo_wpns_msdivr" id="summary_current_infect">
        <div class="title_hdiv"><b>Infections in last scan</b></div>
        <hr class="line">
        <p class="wpns_font_size mo_wpns_scan_summary_text" id="summary_current_infect_text"> <?php echo esc_html($malicious_last_scan) ?> </p>
    </div>
    <div class="mo_wpns_sub_scansummary mo_wpns_msdivr" id="summary_current_warning">
        <div class="title_hdiv"><b>Warnings in last scan</b></div>
        <hr class="line">
        <p class="wpns_font_size mo_wpns_scan_summary_text" id="summary_current_warning_text"> <?php echo esc_html($warning_last_scan) ?> </p>
    </div>

	<?php
}